   MEMBER

!---------------------------------------------------------------------------
! Scanner class
!---------------------------------------------------------------------------

   INCLUDE('EQUATES.CLW'),ONCE
   INCLUDE('ERRORS.CLW'),ONCE
   INCLUDE('KEYCODES.CLW'),ONCE
   INCLUDE('VOYAGER.INC'),ONCE

_Scanner   &Scanner

  MAP
    ScanWindow
  END

ScanWindow         PROCEDURE
ScannerWindow      WINDOW('Voyager'),TIMER(5)
                   END
  CODE
  OPEN(ScannerWindow)
  ScannerWindow{PROP:Hide} = TRUE
  ACCEPT
  CASE EVENT()
  OF EVENT:Timer
    IF _Scanner.ReadPort()
      Pos# = INSTRING('<13,10>',_Scanner.Buffer1024Read,1,1)
      IF Pos#
        _Scanner.ScanCode = SUB(_Scanner.Buffer1024Read,1,Pos#-1)
        CLEAR(_Scanner.Buffer1024Read)
      END
    END
  END
  END
  CLOSE(ScannerWindow)

Scanner.Construct                   PROCEDURE
  CODE

Scanner.Destruct                    PROCEDURE
  CODE

Scanner.Init                        PROCEDURE(STRING CommPort, *STRING ScanCode)
  CODE
  SELF.CommPort = CLIP(CommPort)&'<0>'
  SELF.ScanCode &= ScanCode
  _Scanner &= SELF

Scanner.Kill                        PROCEDURE
  CODE
  SELF.ClosePort

Scanner.ClosePort                   PROCEDURE
RetValue                            LONG
  CODE
  IF SELF.WinThread
    POST(EVENT:CloseWindow,,SELF.WinThread)
    LOOP 1000 TIMES
      YIELD
    END
  END
  IF SELF.PortOpened = TRUE
    IF ~CloseHandle(SELF.PortHandle)
      !MESSAGE('PORT CLOSING ERROR '&SELF.CommPort&'<10>Error code ' & GetLastError())
    END
    SELF.PortOpened = FALSE
  ELSE
    RETURN
  END

Scanner.OpenPort                    PROCEDURE()!,BYTE
RetValue                            LONG
  CODE
  IF SELF.PortOpened = FALSE                                !+GENERIC_WRITE
    SELF.PortHandle = _CreateFile(SELF.CommPort,GENERIC_READ,0,0,OPEN_EXISTING,0,0)
    IF SELF.PortHandle = xINVALID_HANDLE_VALUE
      !MESSAGE('Port Opening Error '&SELF.CommPort&'<10>Error code ' & GetLastError())
      RETURN(TRUE)
    END
    RetValue = GetCommState(SELF.PortHandle, SELF.DCB)
    IF RetValue >= 0
      SELF.Mode = CLIP(SELF.CommPort)&':9600,N,8,1'
      RetValue = BuildCommDCB(SELF.Mode, SELF.DCB)
      IF RetValue >= 0
        RetValue = SetCommState(SELF.PortHandle, SELF.DCB)
        IF RetValue >= 0
          RetValue = PurgeComm(SELF.PortHandle, PURGE_TXABORT+PURGE_RXABORT+PURGE_TXCLEAR+PURGE_RXCLEAR)
          IF RetValue < 0
            !MESSAGE('PORT SETTING ERROR!','MESSAGE',ICON:Asterisk,BUTTON:Ok,BUTTON:Ok,1)
            RETURN(TRUE)
          ELSE
            SELF.COMMTIMEOUTS.ReadIntervalTimeout        = 10
            SELF.COMMTIMEOUTS.ReadTotalTimeoutConstant   = 10
            SELF.COMMTIMEOUTS.ReadTotalTimeoutMultiplier = 1
            Err# = SetCommTimeouts(SELF.PortHandle, SELF.COMMTIMEOUTS)
            IF RetValue < 0
              !MESSAGE('ERROR ON SET TIMEOUT!','MESSAGE',ICON:Asterisk,BUTTON:Ok,BUTTON:Ok,1)
              RETURN(TRUE)
            ELSE
              SELF.WinThread = START(ScanWindow,25000)
            END
          END
        ELSE
          !MESSAGE('PORT INIT ERROR!','MESSAGE',ICON:Asterisk,BUTTON:Ok,BUTTON:Ok,1)
          RETURN(TRUE)
        END
      ELSE
        !MESSAGE('DCB BUILD ERROR!','MESSAGE',ICON:Asterisk,BUTTON:Ok,BUTTON:Ok,1)
        RETURN(TRUE)
      END
    ELSE
      !MESSAGE('DCB READ ERROR!','MESSAGE',ICON:Asterisk,BUTTON:Ok,BUTTON:Ok,1)
      RETURN(TRUE)
    END
    SELF.PortOpened = TRUE
  END
  RETURN(FALSE)

Scanner.ReadPort                    PROCEDURE()!,BYTE
RetValue                            LONG
Buffer32Read                        CSTRING(32)
BytesRead                           LONG
  CODE
  IF SELF.PortOpened
    RetValue = _ReadFile(SELF.PortHandle, ADDRESS(Buffer32Read), SIZE(Buffer32Read), BytesRead, 0)
    IF BytesRead
      SELF.Buffer1024Read = CLIP(SELF.Buffer1024Read) & Buffer32Read[1 : BytesRead]
      Buffer32Read = ''
      RETURN TRUE
    END
  END

