!ABCIncludeFile
!---------------------------------------------------------------------------
! Scanner class
!---------------------------------------------------------------------------

  OMIT('_EndOfInclude_',_ScannerClassClassPresent_)
_ScannerClassClassPresent_  EQUATE(1)

  INCLUDE('svapi.inc')

TCOMMTIMEOUTS               GROUP,TYPE
ReadIntervalTimeout           LONG
ReadTotalTimeoutMultiplier    LONG
ReadTotalTimeoutConstant      LONG
WriteTotalTimeoutMultiplier   LONG
WriteTotalTimeoutConstant     LONG
                            END

TDCB                      GROUP,TYPE
DCBlength                   ULONG     ! sizeof(DCB)
BaudRate                    ULONG     ! current baud rate
fBinary                     ULONG(1)  !  binary mode, no EOF check
fParity                     ULONG(1)  !  enable parity checking
fOutxCtsFlow                ULONG(1)  !  CTS output flow control
fOutxDsrFlow                ULONG(1)  !  DSR output flow control
fDtrControl                 ULONG(2)  !  DTR flow control type
fDsrSensitivity             ULONG(1)  !  DSR sensitivity

fTXContinueOnXoff           ULONG(1)  !  XOFF continues Tx
fOutX                       ULONG(1)  !  XON/XOFF out flow control
fInX                        ULONG(1)  !  XON/XOFF in flow control
fErrorChar                  ULONG(1)  !  enable error replacement
fNull                       ULONG(1)  !  enable null stripping
fRtsControl                 ULONG(2)  !  RTS flow control
fAbortOnError               ULONG(1)  !  abort reads/writes on error
fDummy2                     ULONG(17) !  reserved
wReserved                   SIGNED    !  not currently used

XonLim                      SIGNED    !  transmit XON threshold
XoffLim                     SIGNED    !  transmit XOFF threshold

Parity                      BYTE      !  0-4=no,odd,even,mark,space
StopBits                    BYTE      !  0,1,2 = 1, 1.5, 2
XonChar                     BYTE      !  Tx and Rx XON character
XoffChar                    BYTE      !  Tx and Rx XOFF character
ErrorChar                   BYTE      !  error replacement character

EofChar                     BYTE      !  end of input character
EvtChar                     BYTE      !  received event character
wReserved1                  SIGNED    !  reserved  do not use
                          END

                          MAP
                            INCLUDE('svapifnc.inc')
                            MODULE('API')
                              _CreateFile(*CSTRING,ULONG,ULONG,ULONG,ULONG,ULONG,UNSIGNED),UNSIGNED,PASCAL,RAW,NAME('CreateFileA')
                              _ReadFile(HANDLE hFile, long lpBuffer, long dwBytes, *long dwBytesRead, long lpOverlapped),bool,raw,pascal,NAME('ReadFile')
                              SetCommState(LONG Handle, *TDCB DCB),BYTE,RAW,PASCAL,NAME('SetCommState')
                              GetCommState(LONG Handle, *TDCB DCB),BYTE,RAW,PASCAL,NAME('GetCommState')
                              BuildCommDCB(*CSTRING Mode, *TDCB DCB),BYTE,PASCAL,RAW,NAME('BuildCommDCBA')
                              PurgeComm(LONG Handle, LONG dwFlags),BYTE,PASCAL,RAW,NAME('PurgeComm')
                              GetCommMask(LONG Handle, *ULONG lpEvtMask),BYTE,PASCAL,RAW,NAME('GetCommMask')
                              SetCommMask(LONG Handle, *ULONG lpEvtMask),BYTE,PASCAL,RAW,NAME('SetCommMask')
                              SetCommTimeouts(LONG Handle, *TCOMMTIMEOUTS COMMTIMEOUTS),BYTE,PASCAL,RAW,NAME('SetCommTimeouts')
                            END
                          END

xINVALID_HANDLE_VALUE     EQUATE(-1)
PURGE_TXABORT             EQUATE(1)
PURGE_RXABORT             EQUATE(2)
PURGE_TXCLEAR             EQUATE(4)
PURGE_RXCLEAR             EQUATE(8)


Scanner                   CLASS,TYPE,MODULE('voyager.clw'),TYPE,LINK('voyager.clw',_ABCLinkMode_),DLL(_ABCDllMode_)
Buffer1024Read              CSTRING(1024)
Mode                        CSTRING(100)
ScanCode                    &STRING
DCB                         LIKE(TDCB)
COMMTIMEOUTS                LIKE(TCOMMTIMEOUTS)
PortOpened                  BYTE
PortHandle                  LONG
CommPort                    CSTRING(100)
WinThread                   LONG

Construct                   PROCEDURE
Destruct                    PROCEDURE
Init                        PROCEDURE(STRING CommPort, *STRING ScanCode)
OpenPort                    PROCEDURE(),BYTE
ClosePort                   PROCEDURE
ReadPort                    PROCEDURE(),BYTE
Kill                        PROCEDURE
                          END

_EndOfInclude_